hdu1087(动态规划)

         Super Jumping! Jumping! Jumping!

Problem Description

Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.
The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.

Your task is to output the maximum value according to the given chessmen list.

Input

Input contains multiple test cases. Each test case is described in a line as follow:N value_1 value_2 …value_N It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.

A test case starting with 0 terminates the input and this test case is not to be processed.

Output

For each case, print the maximum according to rules, and one line one case.

Sample Input
3 1 3 2
4 1 2 3 4
4 3 3 2 1
0

Sample Output
4
10
3

链接:http://acm.hdu.edu.cn/showproblem.php?pid=1087

思路:
(自己)一开始用一般的搜索模板,写一个dfs函数,每次搜索从当前开始,搜索比当前大的数,然后倒过去查找,发现行不通
(网上)动态规划,公式:ans = max(ans, dp[i])
两个循环,主要在第二个循环中查找,第一个循环是从当前开始的每找一个比之大的数,第二个循环是找到比之大的数后不断更新。
真的很聪明,ans是当前的最大的,dp注意的是比如dp[3]是指从前面到3为止最大的数之和。1(1),2(2),3(3),2(4),4(5)中dp[4]的值是1+2为3,在第二个循环中,每次查找比之前大的数,同时把更大的数存在ans中。

代码:

#include <iostream>
#include <cstring>
#include <cstdio>
#include <cmath>
using namespace std;
int a[1100];
int dp[1100];
const int minn = -99999999;
int main()
{
    int n;
    while(cin >> n && n != 0)
    {
        memset(dp, 0 ,sizeof dp);
        for(int i=1; i<=n; i++)
            cin >> a[i];
        int ans = minn;
        for(int i=1; i<=n; i++)
        {
            for(int j=0; j<i; j++)
            {
                if(a[i] > a[j])//不仅要找符合条件的
                    ans = max(ans, dp[j]);//还要找符合条件中更大的数
            }
            dp[i] = a[i]+ ans;
        }
        ans = minn;
        for(int i=0; i<=n; i++)
        {
            if(ans < dp[i])
                ans  =  dp[i];
        }
        cout << ans << endl;
    }
    return 0;
}
    原文作者:动态规划
    原文地址: https://blog.csdn.net/qq_35399846/article/details/54846788
    本文转自网络文章,转载此文章仅为分享知识,如有侵权,请联系博主进行删除。
点赞